"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FirebaseCloudStorage = void 0;
var entropic_bond_1 = require("entropic-bond");
var firebase_helper_1 = require("../firebase-helper");
var FirebaseCloudStorage = /** @class */ (function (_super) {
    __extends(FirebaseCloudStorage, _super);
    function FirebaseCloudStorage(emulator) {
        var _this = _super.call(this) || this;
        if (emulator)
            firebase_helper_1.FirebaseHelper.useEmulator(emulator);
        var _a = firebase_helper_1.FirebaseHelper.emulator, emulate = _a.emulate, host = _a.host, storagePort = _a.storagePort;
        if (emulate) {
            firebase_helper_1.FirebaseHelper.instance.storage().useEmulator(host, storagePort);
        }
        return _this;
    }
    FirebaseCloudStorage_1 = FirebaseCloudStorage;
    FirebaseCloudStorage.prototype.store = function (id, data) {
        var _this = this;
        var storage = firebase_helper_1.FirebaseHelper.instance.storage();
        return new Promise(function (resolve, reject) {
            _this._uploadTask = storage.ref().child(id).put(data);
            _this._uploadTask
                .then(function () { return resolve(id); })
                .catch(function (error) { return reject(error); });
        });
    };
    FirebaseCloudStorage.prototype.getUrl = function (reference) {
        if (!reference)
            return Promise.resolve(undefined);
        var storage = firebase_helper_1.FirebaseHelper.instance.storage();
        return storage.ref().child(reference).getDownloadURL();
    };
    FirebaseCloudStorage.prototype.uploadControl = function () {
        var _this = this;
        return {
            cancel: function () { return _this._uploadTask.cancel(); },
            pause: function () { return _this._uploadTask.pause(); },
            resume: function () { return _this._uploadTask.resume(); },
            onProgress: function (callback) { return _this._uploadTask.on('state_changed', function (snapShot) {
                if (callback) {
                    callback(snapShot.bytesTransferred, snapShot.totalBytes);
                }
            }); }
        };
    };
    FirebaseCloudStorage.prototype.delete = function (reference) {
        var storage = firebase_helper_1.FirebaseHelper.instance.storage();
        return storage.ref().child(reference).delete();
    };
    var FirebaseCloudStorage_1;
    FirebaseCloudStorage = FirebaseCloudStorage_1 = __decorate([
        entropic_bond_1.registerCloudStorage('FirebaseCloudStorage', function () { return new FirebaseCloudStorage_1(); })
    ], FirebaseCloudStorage);
    return FirebaseCloudStorage;
}(entropic_bond_1.CloudStorage));
exports.FirebaseCloudStorage = FirebaseCloudStorage;
//# sourceMappingURL=firebase-cloud-storage.js.map