"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
global.XMLHttpRequest = require('xhr2');
var node_fetch_1 = __importDefault(require("node-fetch"));
var firebase_cloud_storage_1 = require("./firebase-cloud-storage");
var firebase_helper_1 = require("../firebase-helper");
var firebase_datasource_1 = require("../store/firebase-datasource");
var entropic_bond_1 = require("entropic-bond");
// Note about tests leaking. I've been checking and looks like firebase.storage 
// methods are the responsible for the test leaking (as firebase v. 8.6.3).
var File = /** @class */ (function () {
    function File() {
    }
    return File;
}());
global.File = File;
var Test = /** @class */ (function (_super) {
    __extends(Test, _super);
    function Test() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._file = new entropic_bond_1.StoredFile();
        return _this;
    }
    Object.defineProperty(Test.prototype, "file", {
        get: function () {
            return this._file;
        },
        enumerable: false,
        configurable: true
    });
    __decorate([
        entropic_bond_1.persistent
    ], Test.prototype, "_file", void 0);
    Test = __decorate([
        entropic_bond_1.registerPersistentClass('Test')
    ], Test);
    return Test;
}(entropic_bond_1.Persistent));
describe('Firebase Cloud Storage', function () {
    var blobData1 = new Uint8Array([0x48, 0x65, 0x6c, 0x6c, 0x6f, 0x2c, 0x20, 0x77, 0x6f, 0x72, 0x6c, 0x64, 0x21]);
    var blobData2 = new Uint8Array([0x6c, 0x6c, 0x6f, 0x2c, 0x48, 0x65, 0x20, 0x77, 0x6f, 0x72, 0x6c, 0x64, 0x21]);
    var file;
    firebase_helper_1.FirebaseHelper.setFirebaseConfig({
        projectId: 'demo-test',
        storageBucket: 'default-bucket'
    });
    firebase_helper_1.FirebaseHelper.useEmulator({ firestorePort: 9080 });
    entropic_bond_1.Store.useDataSource(new firebase_datasource_1.FirebaseDatasource());
    beforeEach(function () {
        entropic_bond_1.CloudStorage.useCloudStorage(new firebase_cloud_storage_1.FirebaseCloudStorage());
        file = new entropic_bond_1.StoredFile();
    });
    it('should save and get a url', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, file.store(blobData1)];
                case 1:
                    _a.sent();
                    expect(file.url).toContain(file.id);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should report metadata', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, file.store(blobData1, 'test.dat')];
                case 1:
                    _a.sent();
                    expect(file.originalFileName).toEqual('test.dat');
                    expect(file.provider.className).toEqual('FirebaseCloudStorage');
                    return [2 /*return*/];
            }
        });
    }); });
    it('should delete file', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, file.store(blobData1)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, file.delete()];
                case 2:
                    _a.sent();
                    expect(file.url).not.toBeDefined();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should overwrite file on subsequent writes', function () { return __awaiter(void 0, void 0, void 0, function () {
        var firstUrl, resp, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, file.store(blobData1)];
                case 1:
                    _c.sent();
                    firstUrl = file.url;
                    return [4 /*yield*/, node_fetch_1.default(file.url)];
                case 2:
                    resp = _c.sent();
                    _a = expect;
                    return [4 /*yield*/, resp.text()];
                case 3:
                    _a.apply(void 0, [_c.sent()]).toEqual('Hello, world!');
                    return [4 /*yield*/, file.store(blobData2)];
                case 4:
                    _c.sent();
                    return [4 /*yield*/, node_fetch_1.default(file.url)];
                case 5:
                    resp = _c.sent();
                    expect(file.url.slice(0, file.url.indexOf('token'))).toEqual(firstUrl.slice(0, firstUrl.indexOf('token')));
                    _b = expect;
                    return [4 /*yield*/, resp.text()];
                case 6:
                    _b.apply(void 0, [_c.sent()]).toEqual('llo,He world!');
                    return [2 /*return*/];
            }
        });
    }); });
    it('should trigger events', function (done) {
        var cb = jest.fn();
        file.store(blobData1).then(function () {
            expect(cb).toHaveBeenCalledTimes(2);
            done();
        });
        file.uploadControl().onProgress(cb);
    });
    describe('Streaming', function () {
        var model;
        var testObj;
        beforeEach(function () {
            testObj = new Test();
            model = entropic_bond_1.Store.getModel(testObj);
        });
        it('should load object with StoredFile', function () { return __awaiter(void 0, void 0, void 0, function () {
            var newTestObj;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, testObj.file.store(blobData1, 'test.dat')];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, model.save(testObj)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, model.findById(testObj.id)];
                    case 3:
                        newTestObj = _a.sent();
                        expect(newTestObj.file).toBeInstanceOf(entropic_bond_1.StoredFile);
                        expect(newTestObj.file.url).toContain(testObj.file.id);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should replace file on save after load', function () { return __awaiter(void 0, void 0, void 0, function () {
            var deleteSpy, newTestObj;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        deleteSpy = jest.spyOn(testObj.file, 'delete');
                        return [4 /*yield*/, testObj.file.store(blobData1, 'test.dat')];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, model.save(testObj)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, model.findById(testObj.id)];
                    case 3:
                        newTestObj = _a.sent();
                        expect(newTestObj.file).toBeInstanceOf(entropic_bond_1.StoredFile);
                        expect(newTestObj.file.url).toContain(testObj.file.id);
                        expect(deleteSpy).not.toHaveBeenCalled();
                        testObj.file.setDataToStore(blobData2);
                        return [4 /*yield*/, testObj.file.store()];
                    case 4:
                        _a.sent();
                        expect(deleteSpy).toHaveBeenCalled();
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=firebase-cloud-storage.spec.js.map