"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FirebaseHelper = void 0;
var firebase_1 = __importDefault(require("firebase"));
require("firebase/auth");
require("firebase/firestore");
require("firebase/storage");
var FirebaseHelper = /** @class */ (function () {
    function FirebaseHelper() {
        if (!FirebaseHelper._firebaseConfig)
            throw new Error('You should set a firebase config object before using Firebase');
        firebase_1.default.initializeApp(FirebaseHelper._firebaseConfig);
    }
    FirebaseHelper.setFirebaseConfig = function (config) {
        FirebaseHelper._firebaseConfig = config;
    };
    FirebaseHelper.useEmulator = function (emulatorConfig) {
        var defaultConfig = {
            host: 'localhost',
            firestorePort: 8080,
            storagePort: 9199,
            authPort: 9099,
            emulate: true
        };
        this._emulatorConfig = __assign(__assign({}, defaultConfig), emulatorConfig);
    };
    Object.defineProperty(FirebaseHelper, "emulator", {
        get: function () {
            return this._emulatorConfig;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FirebaseHelper, "instance", {
        get: function () {
            return this._instance || (this._instance = new FirebaseHelper());
        },
        enumerable: false,
        configurable: true
    });
    FirebaseHelper.prototype.firestore = function () {
        return firebase_1.default.firestore();
    };
    FirebaseHelper.prototype.storage = function () {
        return firebase_1.default.storage();
    };
    FirebaseHelper.prototype.auth = function () {
        return firebase_1.default.auth();
    };
    return FirebaseHelper;
}());
exports.FirebaseHelper = FirebaseHelper;
//# sourceMappingURL=firebase-helper.js.map