"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var node_fetch_1 = __importDefault(require("node-fetch"));
var entropic_bond_1 = require("entropic-bond");
var firebase_datasource_1 = require("./firebase-datasource");
var firebase_helper_1 = require("../firebase-helper");
var test_user_1 = require("../mocks/test-user");
var mock_data_json_1 = __importDefault(require("../mocks/mock-data.json"));
function loadTestData(model) {
    return __awaiter(this, void 0, void 0, function () {
        var users, promises, key, user;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    users = mock_data_json_1.default.TestUser;
                    promises = [];
                    for (key in users) {
                        user = entropic_bond_1.Persistent.createInstance(users[key]);
                        promises.push(model.save(user));
                    }
                    return [4 /*yield*/, Promise.all(promises)];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
describe('Firestore Model', function () {
    var model;
    var testUser;
    firebase_helper_1.FirebaseHelper.setFirebaseConfig({
        projectId: "demo-test",
    });
    firebase_helper_1.FirebaseHelper.useEmulator({ firestorePort: 9080 });
    beforeEach(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    entropic_bond_1.Store.useDataSource(new firebase_datasource_1.FirebaseDatasource());
                    testUser = new test_user_1.TestUser();
                    testUser.name = {
                        firstName: 'testUserFirstName',
                        lastName: 'testUserLastName'
                    };
                    testUser.age = 35;
                    testUser.skills = ['lazy', 'dirty'];
                    model = entropic_bond_1.Store.getModel('TestUser');
                    return [4 /*yield*/, loadTestData(model)];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    afterEach(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    firebase_helper_1.FirebaseHelper.instance.firestore().terminate();
                    return [4 /*yield*/, node_fetch_1.default('http://localhost:9080/emulator/v1/projects/demo-test/databases/(default)/documents', {
                            method: 'DELETE'
                        })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should find document by id', function () { return __awaiter(void 0, void 0, void 0, function () {
        var user;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, model.save(testUser)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, model.findById(testUser.id)];
                case 2:
                    user = _a.sent();
                    expect(user).toBeInstanceOf(test_user_1.TestUser);
                    expect(user.id).toEqual(testUser.id);
                    expect(user.name.firstName).toEqual('testUserFirstName');
                    return [2 /*return*/];
            }
        });
    }); });
    it('should write a document', function () { return __awaiter(void 0, void 0, void 0, function () {
        var newUser;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, model.save(testUser)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, model.findById(testUser.id)];
                case 2:
                    newUser = _a.sent();
                    expect(newUser.name).toEqual({
                        firstName: 'testUserFirstName',
                        lastName: 'testUserLastName'
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('should delete a document by id', function () { return __awaiter(void 0, void 0, void 0, function () {
        var newUser, deletedUser;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, model.save(testUser)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, model.findById(testUser.id)];
                case 2:
                    newUser = _a.sent();
                    expect(newUser.age).toBe(35);
                    return [4 /*yield*/, model.delete(testUser.id)];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, model.findById(testUser.id)];
                case 4:
                    deletedUser = _a.sent();
                    expect(deletedUser).toBeUndefined();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should not throw if a document id doesn\'t exists', function (done) {
        expect(function () {
            model.findById('nonExistingId')
                .then(done)
                .catch(done);
        }).not.toThrow();
    });
    it('should return undefined if a document id doesn\'t exists', function () { return __awaiter(void 0, void 0, void 0, function () {
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = expect;
                    return [4 /*yield*/, model.findById('nonExistingId')];
                case 1:
                    _a.apply(void 0, [_b.sent()]).toBeUndefined();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should retrieve array fields', function () { return __awaiter(void 0, void 0, void 0, function () {
        var newUser;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, model.save(testUser)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, model.findById(testUser.id)];
                case 2:
                    newUser = _a.sent();
                    expect(Array.isArray(newUser.skills)).toBeTruthy();
                    expect(newUser.skills).toEqual(expect.arrayContaining(['lazy', 'dirty']));
                    return [2 /*return*/];
            }
        });
    }); });
    it('should retrieve object fields', function () { return __awaiter(void 0, void 0, void 0, function () {
        var newUser;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, model.save(testUser)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, model.findById(testUser.id)];
                case 2:
                    newUser = _a.sent();
                    expect(newUser.name).toEqual({
                        firstName: 'testUserFirstName',
                        lastName: 'testUserLastName'
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    describe('Generic find', function () {
        it('should query all admins with query object', function () { return __awaiter(void 0, void 0, void 0, function () {
            var admins;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        testUser.admin = true;
                        return [4 /*yield*/, model.save(testUser)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, model.query({
                                operations: [{
                                        property: 'admin',
                                        operator: '==',
                                        value: true
                                    }]
                            })];
                    case 2:
                        admins = _a.sent();
                        expect(admins.length).toBeGreaterThanOrEqual(1);
                        expect(admins[0]).toBeInstanceOf(test_user_1.TestUser);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should find all admins with where methods', function () { return __awaiter(void 0, void 0, void 0, function () {
            var admins;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.find().where('admin', '==', true).get()];
                    case 1:
                        admins = _a.sent();
                        expect(admins.length).toBeGreaterThanOrEqual(1);
                        expect(admins[0]).toBeInstanceOf(test_user_1.TestUser);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should find admins with age less than 56', function () { return __awaiter(void 0, void 0, void 0, function () {
            var admins;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.find()
                            .where('admin', '==', true)
                            .where('age', '<', 50)
                            .get()];
                    case 1:
                        admins = _a.sent();
                        expect(admins.length).toBeGreaterThanOrEqual(1);
                        expect(admins[0].age).toBeLessThan(50);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should query by subproperties', function () { return __awaiter(void 0, void 0, void 0, function () {
            var users;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.query({
                            operations: [
                                {
                                    property: 'name',
                                    operator: '==',
                                    value: { firstName: 'userFirstName3' }
                                },
                                { property: 'age', operator: '!=', value: 134 }
                            ]
                        })];
                    case 1:
                        users = _a.sent();
                        expect(users[0].id).toBe('user3');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should find by subproperties', function () { return __awaiter(void 0, void 0, void 0, function () {
            var users;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.find()
                            .where('name', '==', { firstName: 'userFirstName3' })
                            .get()];
                    case 1:
                        users = _a.sent();
                        expect(users[0].id).toBe('user3');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should find by property path', function () { return __awaiter(void 0, void 0, void 0, function () {
            var users;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.find()
                            .whereDeepProp('name.firstName', '==', 'userFirstName3')
                            .get()];
                    case 1:
                        users = _a.sent();
                        expect(users[0].id).toBe('user3');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should find by superdeep property path', function () { return __awaiter(void 0, void 0, void 0, function () {
            var users;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.find()
                            .whereDeepProp('name.ancestorName.father', '==', 'user3Father')
                            .get()];
                    case 1:
                        users = _a.sent();
                        expect(users[0].id).toEqual('user3');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should find by swallow property path', function () { return __awaiter(void 0, void 0, void 0, function () {
            var users;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.find()
                            .whereDeepProp('age', '==', 21)
                            .get()];
                    case 1:
                        users = _a.sent();
                        expect(users[0].id).toEqual('user2');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('Derived classes should fit on parent collection', function () {
        it('should save derived object in parent collection', function () { return __awaiter(void 0, void 0, void 0, function () {
            var derived, newUser;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        derived = new test_user_1.DerivedUser();
                        derived.name = { firstName: 'Fulanito', lastName: 'Derived' };
                        derived.salary = 3900;
                        return [4 /*yield*/, model.save(derived)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, model.findById(derived.id)];
                    case 2:
                        newUser = _a.sent();
                        expect(newUser).toBeInstanceOf(test_user_1.DerivedUser);
                        expect(newUser.salary).toBe(3900);
                        expect(newUser.className).toEqual('DerivedUser');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('References to documents', function () {
        var ref1, ref2;
        beforeEach(function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        testUser.documentRef = new test_user_1.SubClass();
                        testUser.documentRef.year = 2045;
                        ref1 = new test_user_1.SubClass();
                        ref1.year = 2081;
                        ref2 = new test_user_1.SubClass();
                        ref2.year = 2082;
                        testUser.manyRefs.push(ref1);
                        testUser.manyRefs.push(ref2);
                        testUser.derived = new test_user_1.DerivedUser();
                        testUser.derived.salary = 1350;
                        testUser.manyDerived = [new test_user_1.DerivedUser(), new test_user_1.DerivedUser()];
                        testUser.manyDerived[0].salary = 990;
                        testUser.manyDerived[1].salary = 1990;
                        return [4 /*yield*/, model.save(testUser)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('should save a document as a reference', function () { return __awaiter(void 0, void 0, void 0, function () {
            var subClassModel, newDocument;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        subClassModel = entropic_bond_1.Store.getModel('SubClass');
                        expect(subClassModel).toBeDefined();
                        return [4 /*yield*/, subClassModel.findById(testUser.documentRef.id)];
                    case 1:
                        newDocument = _a.sent();
                        expect(newDocument).toBeInstanceOf(test_user_1.SubClass);
                        expect(newDocument.year).toBe(2045);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should read a swallow document reference', function () { return __awaiter(void 0, void 0, void 0, function () {
            var loadedUser;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.findById(testUser.id)];
                    case 1:
                        loadedUser = _a.sent();
                        expect(loadedUser.documentRef).toBeInstanceOf(test_user_1.SubClass);
                        expect(loadedUser.documentRef.id).toBeUndefined();
                        expect(loadedUser.documentRef.year).toBeUndefined();
                        return [2 /*return*/];
                }
            });
        }); });
        it('should fill data of swallow document reference', function () { return __awaiter(void 0, void 0, void 0, function () {
            var loadedUser;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.findById(testUser.id)];
                    case 1:
                        loadedUser = _a.sent();
                        return [4 /*yield*/, entropic_bond_1.Store.populate(loadedUser.documentRef)];
                    case 2:
                        _a.sent();
                        expect(loadedUser.documentRef.id).toBeDefined();
                        expect(loadedUser.documentRef.year).toBe(2045);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should save and array of references', function () { return __awaiter(void 0, void 0, void 0, function () {
            var subClassModel, newDocument;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        subClassModel = entropic_bond_1.Store.getModel('SubClass');
                        return [4 /*yield*/, subClassModel.findById(testUser.documentRef.id)];
                    case 1:
                        newDocument = _a.sent();
                        expect(newDocument).toBeInstanceOf(test_user_1.SubClass);
                        expect(newDocument.year).toBe(2045);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should read an array of references', function () { return __awaiter(void 0, void 0, void 0, function () {
            var loadedUser;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.findById(testUser.id)];
                    case 1:
                        loadedUser = _a.sent();
                        expect(loadedUser.manyRefs).toHaveLength(2);
                        expect(loadedUser.manyRefs[0]).toBeInstanceOf(test_user_1.SubClass);
                        expect(loadedUser.manyRefs[0].id).toBeUndefined();
                        expect(loadedUser.manyRefs[0].year).toBeUndefined();
                        expect(loadedUser.manyRefs[1]).toBeInstanceOf(test_user_1.SubClass);
                        expect(loadedUser.manyRefs[1].id).toBeUndefined();
                        expect(loadedUser.manyRefs[1].year).toBeUndefined();
                        return [2 /*return*/];
                }
            });
        }); });
        it('should fill array of refs', function () { return __awaiter(void 0, void 0, void 0, function () {
            var loadedUser;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.findById(testUser.id)];
                    case 1:
                        loadedUser = _a.sent();
                        return [4 /*yield*/, entropic_bond_1.Store.populate(loadedUser.manyRefs)];
                    case 2:
                        _a.sent();
                        expect(loadedUser.manyRefs[0].year).toBe(2081);
                        expect(loadedUser.manyRefs[1].year).toBe(2082);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should save a reference when declared @persistentAt', function () { return __awaiter(void 0, void 0, void 0, function () {
            var loadedUser;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.findById(testUser.id)];
                    case 1:
                        loadedUser = _a.sent();
                        expect(loadedUser.derived.id).toBeUndefined();
                        return [4 /*yield*/, entropic_bond_1.Store.populate(loadedUser.derived)];
                    case 2:
                        _a.sent();
                        expect(loadedUser.derived.salary).toBe(1350);
                        expect(loadedUser.derived.id).toBe(testUser.derived.id);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should populate from special collection when declared with @persistentRefAt', function () { return __awaiter(void 0, void 0, void 0, function () {
            var loadedUser;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.findById('user6')];
                    case 1:
                        loadedUser = _a.sent();
                        return [4 /*yield*/, entropic_bond_1.Store.populate(loadedUser.derived)];
                    case 2:
                        _a.sent();
                        expect(loadedUser.derived.salary).toBe(2800);
                        expect(loadedUser.derived.id).toBe('user4');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should save a reference when declared @persistentAt as array', function () { return __awaiter(void 0, void 0, void 0, function () {
            var loadedUser;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.findById(testUser.id)];
                    case 1:
                        loadedUser = _a.sent();
                        expect(loadedUser.manyDerived[0].id).toBeUndefined();
                        return [4 /*yield*/, entropic_bond_1.Store.populate(loadedUser.manyDerived)];
                    case 2:
                        _a.sent();
                        expect(loadedUser.manyDerived[0].salary).toBe(990);
                        expect(loadedUser.manyDerived[0].id).toBe(testUser.manyDerived[0].id);
                        expect(loadedUser.manyDerived[1].salary).toBe(1990);
                        expect(loadedUser.manyDerived[1].id).toBe(testUser.manyDerived[1].id);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should not overwrite not filled ref in collection', function () { return __awaiter(void 0, void 0, void 0, function () {
            var loadedUser, refInCollection;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.findById('user6')];
                    case 1:
                        loadedUser = _a.sent();
                        return [4 /*yield*/, model.save(loadedUser)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, model.findById('user4')];
                    case 3:
                        refInCollection = _a.sent();
                        expect(refInCollection.salary).toBe(2800);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should save loaded ref with assigned new instance', function () { return __awaiter(void 0, void 0, void 0, function () {
            var loadedUser, refInCollection;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.findById('user6')];
                    case 1:
                        loadedUser = _a.sent();
                        loadedUser.derived = new test_user_1.DerivedUser();
                        loadedUser.derived.salary = 345;
                        return [4 /*yield*/, model.save(loadedUser)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, model.findById(loadedUser.derived.id)];
                    case 3:
                        refInCollection = _a.sent();
                        expect(refInCollection.salary).toBe(345);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should save loaded ref with modified ref data', function () { return __awaiter(void 0, void 0, void 0, function () {
            var loadedUser, refInCollection;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.findById('user6')];
                    case 1:
                        loadedUser = _a.sent();
                        return [4 /*yield*/, entropic_bond_1.Store.populate(loadedUser.derived)];
                    case 2:
                        _a.sent();
                        loadedUser.derived.salary = 1623;
                        return [4 /*yield*/, model.save(loadedUser)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, model.findById('user4')];
                    case 4:
                        refInCollection = _a.sent();
                        expect(refInCollection.salary).toBe(1623);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('Operations on queries', function () {
        it('should limit the result set', function () { return __awaiter(void 0, void 0, void 0, function () {
            var unlimited, limited;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.find().get()];
                    case 1:
                        unlimited = _a.sent();
                        return [4 /*yield*/, model.find().limit(2).get()];
                    case 2:
                        limited = _a.sent();
                        expect(unlimited.length).not.toBe(limited.length);
                        expect(limited).toHaveLength(2);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should sort ascending the result set', function () { return __awaiter(void 0, void 0, void 0, function () {
            var docs;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.find().orderBy('age').get()];
                    case 1:
                        docs = _a.sent();
                        expect(docs[0].id).toEqual('user2');
                        expect(docs[1].id).toEqual('user1');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should sort descending the result set', function () { return __awaiter(void 0, void 0, void 0, function () {
            var docs;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.find().orderBy('age', 'desc').get()];
                    case 1:
                        docs = _a.sent();
                        expect(docs[0].id).toEqual('user3');
                        expect(docs[1].id).toEqual('user5');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should sort by deep property path', function () { return __awaiter(void 0, void 0, void 0, function () {
            var docs;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.find().orderByDeepProp('name.firstName', 'desc').get()];
                    case 1:
                        docs = _a.sent();
                        expect(docs[0].id).toEqual('user6');
                        expect(docs[1].id).toEqual('user5');
                        return [2 /*return*/];
                }
            });
        }); });
        it('should sort by swallow property path', function () { return __awaiter(void 0, void 0, void 0, function () {
            var docs;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, model.find().orderByDeepProp('age').get()];
                    case 1:
                        docs = _a.sent();
                        expect(docs[0].id).toEqual('user2');
                        expect(docs[1].id).toEqual('user1');
                        return [2 /*return*/];
                }
            });
        }); });
        xdescribe('Data Cursors', function () {
            beforeEach(function () { return __awaiter(void 0, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, model.find().get(2)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should get next result set', function () { return __awaiter(void 0, void 0, void 0, function () {
                var docs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, model.next()];
                        case 1:
                            docs = _a.sent();
                            expect(docs).toHaveLength(2);
                            expect(docs[0].id).toEqual('user3');
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should get previous result set', function () { return __awaiter(void 0, void 0, void 0, function () {
                var docs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, model.next()];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, model.next()];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, model.prev()];
                        case 3:
                            docs = _a.sent();
                            expect(docs).toHaveLength(2);
                            expect(docs[0].id).toEqual('user3');
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should not go lower than begining of result set', function () { return __awaiter(void 0, void 0, void 0, function () {
                var docs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, model.prev()];
                        case 1:
                            docs = _a.sent();
                            expect(docs).toHaveLength(0);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should not go beyond the end of result set', function () { return __awaiter(void 0, void 0, void 0, function () {
                var docs;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, model.next()];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, model.next()];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, model.next()];
                        case 3:
                            docs = _a.sent();
                            expect(docs).toHaveLength(0);
                            return [2 /*return*/];
                    }
                });
            }); });
        });
    });
});
//# sourceMappingURL=firebase-datasource.spec.js.map